#!/usr/bin/env ruby
############################################################################
#    Copyright (C) 2008 by David Palacio                                   #
#    dpalacio@uninorte.edu.co                                              #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 3 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          #
############################################################################

class Config
	
	def self.instance
		@instance ||= self.new
	end
	
	def initialize
		@type = {}
	end
	
	def local
		@path ||= config :path
	end
	
	def path( type )
		@type[ type ] ||= (config type).split(':').find { |path| path.start_with? local }
	end

	def config( par )
		option = ''
		case par
		when :path
			option = '--localprefix'
		when :apps, :cgi, :config, :data, :emoticons, :exe, :html, :icon, :kcfg, :locale,
				:mime, :module, :pixmap, :qtplugins, :services, :servicetypes, :sound, :templates, :wallpaper
			option = "--path #{par}"
		end
		`kde4-config #{option}`.strip
	end
	
	def install( type, filename, prefix = '' )
		`cp #{filename} #{path type}#{prefix}`
	end
	
	def mkdir( type, dirname )
		`mkdir -p #{path type}#{dirname}`
	end
	
end

c = Config.instance
c.mkdir :data, 'omaque'
c.install :data, 'mainwindow.rc', 'omaque'
c.install :data, 'okularpart.rb', 'omaque'
c.install :data, 'reader.rb', 'omaque'
c.install :apps, 'omaque.desktop'
if ARGV.include? 'hack'
	puts 'Hacking Okular mimetype'
	c.install :services, 'libokularGenerator_comicbook.desktop'
end
puts 'OK'
